//Projectile_GreenFirework.cs

//Firework trail effects
datablock ParticleData(GreenFireworkTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 2000;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 0;
	spinRandomMin		= 0;
	spinRandomMax		= 0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= " ";

	// Interpolation variables
	colors[0]	= "0 1 0 0.5";
	colors[1]	= "0 1 0.25 0.0";
	sizes[0]	= 0.6;
	sizes[1]	= 0.01;
	times[0]	= 0.0;
	times[1]	= 1.0;
};
datablock ParticleEmitterData(GreenFireworkTrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 0.0;  

   particles = "GreenFireworkTrailParticle";
};

datablock ParticleData(GreenFireworkArmParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 1000;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 0;
	spinRandomMin		= 0;
	spinRandomMax		= 0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= " ";

	// Interpolation variables
	colors[0]	= "0 1 0 0.5";
	colors[1]	= "0 1 0.25 0.0";
	sizes[0]	= 0.3;
	sizes[1]	= 0.01;
	times[0]	= 0.0;
	times[1]	= 1.0;
};
datablock ParticleEmitterData(GreenFireworkArmEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 0.0;  

   particles = "GreenFireworkArmParticle";
};

datablock DebrisData(GreenFireworkArms)
{
   emitters = "GreenFireworkArmEmitter";

	shapeFile = "Add-ons/Weapon_Gun/gunShell.dts";
	lifetime = 3.0;
	minSpinSpeed = 0.0;
	maxSpinSpeed = 0.0;
	elasticity = 0.0;
	friction = 0.5;
	numBounces = 0;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = false;

	gravModifier = 0.5;
};


datablock ParticleData(GreenFireworkExplosionParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.2;
	inheritedVelFactor	= 0.5;
	constantAcceleration	= 0.0;
	lifetimeMS		= 750;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 0.0;
	spinRandomMin		= -5.0;
	spinRandomMax		= 5.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/lighting/flare";
	//animTexName		= "base/data/particles/cloud";

	// Interpolation variables
	colors[0]	= "0 1 0 1";
	colors[1]	= "0 1 0 1";
        colors[2]	= "0 1 0 0";
	sizes[0]	= 1;
	sizes[1]	= 0.6;
	sizes[2]	= 0.2;
	times[0]	= 0.0;
	times[1]	= 0.8;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(GreenFireworkExplosionEmitter)
{
   ejectionPeriodMS = 2.5;
   periodVarianceMS = 0;
   ejectionVelocity = 50;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "GreenFireworkExplosionParticle";
};

datablock ExplosionData(GreenFireworkExplosion)
{
   explosionShape = "";

   lifeTimeMS = 2000;
   soundProfile = FireworkExplodeSound;

   emitter[0] = GreenFireworkExplosionEmitter;
   particleDensity = 70;
   particleRadius = 9.0;

   faceViewer     = true;
   explosionScale = "1 1 1";

   debris = GreenFireworkArms;
   debrisNum = 12;
   debrisNumVariance = 0;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 135;
   debrisVelocity = 14;
   debrisVelocityVariance = 3;

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 10;
   lightEndRadius = 10;
   lightStartColor = "0 1 0 1";
   lightEndColor = "0 1 0 0";

   damageRadius = 3;
   radiusDamage = 50;

   impulseRadius = 6;
   impulseForce = 2000;
};

datablock ProjectileData(GreenFireworkProjectile)
{
   projectileShapeName = "Add-ons/Weapon_Gun/gunShell.dts";
   directDamage        = 15;
   directDamageType = $DamageType::FireworkDirect;
   radiusDamageType = $DamageType::FireworkRadius;
   impactImpulse	   = 500;
   verticalImpulse	   = 500;
   explosion           = GreenFireworkExplosion;
   particleEmitter     = GreenFireworkTrailEmitter;

   brickExplosionRadius = 3;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 20;             
   brickExplosionMaxVolume = 20;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 50;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   explodeOnDeath = true;
   sound = FireworkLoopSound;
   muzzleVelocity      = 30;
   velInheritFactor    = 1.0;
   armingDelay         = 0;
   lifetime            = 2500;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0 1 0.0";
   
   uiName = "Firework, Green"; // So all fireworks are grouped together in the alphabetised projectile list
};